"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Core = function () {
  function Core() {
    _classCallCheck(this, Core);

    this.systems = [];
    this.entities = [];
    this.components = {};

    this.dirtyEntities = [];
  }

  _createClass(Core, [{
    key: "addSystem",
    value: function addSystem(system) {

      this.systems.push(system);

      var i = this.entities.length;

      while (i--) {
        if (system.test(this.entities[i])) {
          system.addEntity(this.entities[i]);
        }
      }
    }
  }, {
    key: "removeSystem",
    value: function removeSystem(system) {

      var index = this.systems.indexOf(system);

      if (index !== -1) {
        this.systems.splice(index, 1);
      }
    }
  }, {
    key: "addEntity",
    value: function addEntity(entity) {

      if (this.entities.indexOf(entity) === -1) {

        this.entities.push(entity);
        entity.core = this;

        var i = this.systems.length;

        while (i--) {
          if (this.systems[i].test(entity)) {
            this.systems[i].addEntity(entity);
          }
        }
      }
    }
  }, {
    key: "removeEntity",
    value: function removeEntity(entity) {

      var index = this.entities.indexOf(entity);

      if (index !== -1) {

        this.entities.splice(index, 1);
        var s = this.systems.length;
        while (s--) {
          this.systems[s].removeEntity(entity);
        }
        entity.core = null;
      }
    }
  }, {
    key: "update",
    value: function update() {

      var d = this.dirtyEntities.length;

      while (d--) {
        var s = this.systems.length;
        while (s--) {
          if (this.systems[s].test(this.dirtyEntities[d])) {
            this.systems[s].addEntity(this.dirtyEntities[d]);
          } else {
            this.systems[s].removeEntity(this.dirtyEntities[d]);
          }
        }
      }

      this.dirtyEntities = [];

      var i = this.systems.length;

      while (i--) {
        var j = this.systems[i].entities.length;
        this.systems[i].preUpdate();
        while (j--) {
          this.systems[i].update(this.systems[i].entities[j]);
        }
        this.systems[i].postUpdate();
      }
    }
  }]);

  return Core;
}();

exports.default = Core;