"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _id = require("./id");

var _id2 = _interopRequireDefault(_id);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Entity = function () {
  function Entity() {
    var components = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    _classCallCheck(this, Entity);

    this.id = (0, _id2.default)();
    this.core = null;
    this.components = {};

    var i = components.length;
    while (i--) {
      this.components[components[i].getName()] = components[i];
    }
  }

  _createClass(Entity, [{
    key: "getId",
    value: function getId() {
      return this.id;
    }
  }, {
    key: "addComponent",
    value: function addComponent(component) {
      this.components[component.getName()] = component;
      if (this.core) {
        this.core.dirtyEntities.push(this);
      }
    }
  }, {
    key: "removeComponent",
    value: function removeComponent(name) {
      if (this.components[name]) {
        delete this.components[name];
        if (this.core) {
          this.core.dirtyEntities.push(this);
        }
      }
    }
  }]);

  return Entity;
}();

exports.default = Entity;